/*********************************************
* This file is resposible for the xul animations of the single engine window.
* @Author: Eylon Yogev
*********************************************/


HeadupClass.prototype.frameRate = 15;
HeadupClass.prototype.increaeSize = 30;
HeadupClass.prototype.isAnimating = false;


HeadupClass.prototype.AnimateTrasition = function(length, action, completed) {
    if (length > 0) {
        this.AnimateTrasitionWithCurrent(0, length, action, completed);
    }
    else {
        if (completed != null)
            completed();
    }
}

HeadupClass.prototype.AnimateTrasitionWithCurrent = function(current, length, action, completed) {
    this.isAnimating = true;
    setTimeout(function() {
        var newSize = current + this.increaeSize;
        if (newSize == length) {
            action(this.increaeSize);
            this.FinishAnimation(completed);
        }
        else if (newSize < length) {
            action(this.increaeSize);
            current += this.increaeSize;
            this.AnimateTrasitionWithCurrent(current, length, action, completed);
        }
        else {
            action(length - current);
            this.FinishAnimation(completed);
        }
    }, this.frameRate);
}

HeadupClass.prototype.FinishAnimation = function(completed) {
    this.isAnimating = false;
    if (completed != null)
        completed();
}

HeadupClass.prototype.AnimateWidth = function(width, completed) {
    if (gHeadup.SingleEngineWindow.outerWidth < width) {
        var action = function(incSize) {
            var newWidth = gHeadup.SingleEngineWindow.outerWidth + incSize;
            if (newWidth <= width)
                gHeadup.SingleEngineWindow.resizeTo(newWidth, gHeadup.SingleEngineWindow.outerHeight);
        };
        this.AnimateTrasition(width - gHeadup.SingleEngineWindow.outerWidth, action, completed);
    }
    else if (gHeadup.SingleEngineWindow.outerWidth > width) {
        var action = function(incSize) {
            var newWidth = gHeadup.SingleEngineWindow.outerWidth - incSize;
            if (newWidth >= width)
                gHeadup.SingleEngineWindow.resizeTo(newWidth, gHeadup.SingleEngineWindow.outerHeight);
        };
        this.AnimateTrasition(gHeadup.SingleEngineWindow.outerWidth - width, action, completed);
    }
    else if (completed != null) {
        completed();
    }
}

HeadupClass.prototype.AnimateHeight = function(Height, completed) {
    if (gHeadup.SingleEngineWindow.outerHeight < Height) {
        var action = function(incSize) {
            var newHeight = gHeadup.SingleEngineWindow.outerHeight + incSize;
            if (newHeight <= Height)
                gHeadup.SingleEngineWindow.resizeTo(gHeadup.SingleEngineWindow.outerWidth, newHeight);
        };
        this.AnimateTrasition(Height - gHeadup.SingleEngineWindow.outerHeight, action, completed);
    }
    else if (gHeadup.SingleEngineWindow.outerHeight > Height) {
        var action = function(incSize) {
            var newHeight = gHeadup.SingleEngineWindow.outerHeight - incSize;
            if (newHeight >= Height)
                gHeadup.SingleEngineWindow.resizeTo(gHeadup.SingleEngineWindow.outerWidth, newHeight);
        };
        this.AnimateTrasition(gHeadup.SingleEngineWindow.outerHeight - Height, action, completed);
    }
    else if (completed != null) {
        completed();
    }
}

HeadupClass.prototype.AnimateHeightThenWidth = function(width, height) {
    if (this.isAnimating == false) {
        if (gHeadup.SingleEngineWindow.outerHeight < height) {
            this.AnimateHeight(height, function() {
                this.AnimateWidth(width, function() { });
            });
        }
        else {
            this.AnimateWidth(width, function() {
                this.AnimateHeight(height, function() { });
            });
        }
    }
    else {
        setTimeout(function() {
            this.AnimateHeightThenWidth(width, height);
        }, 100);
    }
}