/*********************************************
* A static consts file for the extension.
* @Author: Eylon Yogev
*********************************************/

try {
    function HeadupClass() {
    }

    function GetHeadup() {
        return gHeadup;  
    }

    var gHeadup = new HeadupClass();

    HeadupClass.prototype.Consts = new function() {

        // this is the version of the application. this is replaced by the deployment.
        // Don't change this line, it is being replaced by the deployment script!
        this.Version = '1.0.4.8340';

        // headup host
        this.HostApp = 'headup.com';

        // headup site host
        this.HostSite = 'headup.com';

        // The url to the personal engine page. This is not used currently. This is defined again in the SingleEngine.xul
        this.PersonalEngingePage = 'http://' + this.HostApp + '/app/1.0.4.8340/PersonalEnginePage.html';

        // url to the statusbar icon
        this.EnabledIconPath = 'chrome://keybitz/skin/enabled.png';

        // url to the statusbar disable icon
        this.DisabledIconPath = 'chrome://keybitz/skin/disabled.png';

        // url to the statusbar icon on mosue hover
        this.OnoverIconPath = 'chrome://keybitz/skin/onover.png';

        // the id of the image element in the statusbar
        this.KeybitzEnableIconId = 'keybitz.enable.icon';

        // a prefix to a headup icon image id
        this.KeybitzMiniIconElementName = 'keybitz.miniIcon';

        // a url to the login xul. This is the xul we use to show the facebook login window, the gmail one and some more.
        this.LoginWindowChromPath = 'chrome://keybitz/content/login.xul';

        // url to the single window xul. we use this to load the single engine.
        this.SingleEngineChromPath = 'chrome://keybitz/content/SingleEngine.xul';

        // default settings for opening a window. we use these settings when opening the login window.
        this.DefaultWindowFeatures = 'chrome, dialog,dependent=yes,resizable=yes,scrollbars=yes,alwaysRaised=yes';

        // string const for saving the rememeber me option in the login in the about:config
        this.RememberMePref = 'rememberMe';

        // string const for about:config for saving whether the extension is enabled
        this.EnabledPref = 'enabled';

        // const to know that we are in debug more. we change this in the deployment.
        this.DebugPref = 'debug';

        // string const to show in context menu in the statusbar
        this.EnableText = 'Enable Headup';

        // string const to show in context menu in the statusbar
        this.DisableText = 'Disable Headup';

        // const to determine whether to show javascript error that accor in the extension
        this.ShowAlerts = false;

        // const to determine if to out logs in the error console.
        this.UseErrorConsole = false;

        // const save silverlight version. we use this when checking if silverlight is installed in the user's computer.
        this.SilverVersionType = 'application/x-silverlight-2';

        // url to the page when the user's doens't have silverlight installed.
        this.NoPluginPage = 'http://' + this.HostApp + '/silverlight.html';

        // url to page when the user's does have silverlight installed.
        this.PluginIsInstalledPage = 'http://' + this.HostApp + '/install.html';

        // url to start page. this is the page showing "loadgin..." until the xap file is downloaded.
        this.LoadingURL = 'http://' + this.HostApp + '/Start.html';

        // url to start page. this is the page showing "loadgin..." until the xap file is downloaded.
        this.InstallingSilverlightURL = 'http://' + this.HostSite + '/install-sl.html';

        // getting started url page. this is shown after the xap file has been downloaded and the user has signed in.
        this.GetStartedURL = 'http://' + this.HostSite + '/first.html';

        //the installation file name for silverlight. Used to install silverlight if missing.
        this.SilverlightInstallExe = 'Silverlight.2.0.exe';

        this.SilverlightMissing = 'http://' + this.HostApp + '/silverlight_missing.html';

        // the statistics service url to send the installation statistics
        this.StatisticsServiceUrl = 'http://stats.' + this.HostSite + '/StatisticService.ashx';

        // the silverlight installation url for downlading for windows
        this.SilverlightXPDownloadUrl = 'http://go.microsoft.com/fwlink/?LinkID=124807';

        // the silverlight installation url for downlading for mac
        this.SilverlightMacDownloadUrl = 'http://go.microsoft.com/fwlink/?LinkId=107365';
    }

}
catch (err) {
    gHeadup.LogError('error prototyping Consts: ' + err);
}