/*********************************************
* Reponsible of dragging the main window.
* @Author: Eylon Yogev
*********************************************/

try {

    HeadupClass.prototype.theWindow = null;
    HeadupClass.prototype.startPosX = 0;
    HeadupClass.prototype.startPosY = 0;
    HeadupClass.prototype.bStartDrag = false;

    // get a window to make it draggable.
    HeadupClass.prototype.MakeWindowDraggable = function() {
        window.addEventListener("mousedown", this.mouseDown, false);
        window.addEventListener("mouseup", this.mouseUp, false);
    }

    // event when mouse button is clicked. saves the X,Y position of the mouse.
    HeadupClass.prototype.mouseDown = function(event) {
        window.addEventListener("mousemove", gHeadup.mouseMove, false);
        gHeadup.startPosX = event.clientX;
        gHeadup.startPosY = event.clientY;
        //setCursor('grabbing');
    }

    // event when the mouse moves. if needed, moves the window.
    HeadupClass.prototype.mouseMove = function(event) {
        if (gHeadup.bStartDrag) {
            //setCursor('grabbing');
            var browser = gHeadup.GetActiveTab();
            browser.SWX = event.screenX - gHeadup.startPosX;
            browser.SWY = event.screenY - gHeadup.startPosY;
            window.moveTo(browser.SWX, browser.SWY);
        }
    }

    HeadupClass.prototype.SilverMouseUp = function() {
        gHeadup.bStartDrag = false;
        window.removeEventListener("mousemove", gHeadup.mouseMove, false);
        //setCursor('default');
    }

    HeadupClass.prototype.mouseUp = function(event) {
        gHeadup.bStartDrag = false;
        window.removeEventListener("mousemove", gHeadup.mouseMove, false);
        //setCursor('default');  
    }

    HeadupClass.prototype.StartDrag = function(x, y) {
        try {
            gHeadup.startPosX = x;
            gHeadup.startPosY = y;
            gHeadup.bStartDrag = true;
            window.addEventListener("mousemove", gHeadup.mouseMove, false);
        }
        catch (err) {
            gHeadup.LogError('StartDrag', err);
        }
    }

    HeadupClass.prototype.ChangeCursor = function(params) {
        var name = params['name'];
        //setCursor(name);
    }

}
catch (err) {
    gHeadup.LogError('error prototyping Draggable: ' + err);
}