/*********************************************
* Makes an async HTTP request
* @Author: Eylon Yogev
*********************************************/

HeadupClass.prototype.BeginGetResponse = function(params)
{
    try
    {
        var method = params['method'];
        var address = params['address'];
        var data = params['data'];
        var header = params['header'];
        var opid = params['opId'];
		var binaryContent = params['binarycontent'];
		var reciver = params['reciever'];
		
        var xmlhttp = new XMLHttpRequest();
		
		if(binaryContent == "true")
		{
			xmlhttp.overrideMimeType('text/plain; charset=x-user-defined');
		}
		else
		{
			xmlhttp.overrideMimeType('text/xml');
		}

        xmlhttp.onerror = function(req)
        {
            var data2 = {};
            data2['responsetext'] = 'Error! StatusText='+req.statusText+' Contents='+req.responseText;
            data2['opid'] = opid;
            gHeadup.FireEventInWindow('ErrorInExtension', data2, reciver);
            data2 = null;
        }
        
        xmlhttp.onreadystatechange = function()
        {
            if (xmlhttp.readyState == 4)
            {
                var data2 = {};
                data2['opid'] = opid;
                if (xmlhttp.status == 200)
                {
					data2['responsetext'] = xmlhttp.responseText;
					data2['returnedcode'] = xmlhttp.status;
					gHeadup.FireEventInWindow('MethodCallback', data2, reciver);
                }
                else
                {
                    data2['responsetext'] = 'code ' + xmlhttp.status + ' returned';
                    data2['returnedcode'] = xmlhttp.status;
                    gHeadup.FireEventInWindow('ErrorInExtension', data2, reciver);
                }
                
                data2 = null;
            }
        }
        
       xmlhttp.open(method, address, true);
       if (header != null && header != '')
       {
            var headers = header.split('|');
            for (var i = 0; i < headers.length; i++)
            {
                try
                {
                    var headerKeyValue = headers[i].split(':');
                    var headerKey = headerKeyValue[0];
                    var headerValue = headerKeyValue[1];
                    if (headerKey != null && headerKey != '')
                    {
                        xmlhttp.setRequestHeader(headerKey, headerValue);
                    }
                }
                catch (err)
                {
                   // alert('Error parsin header: ' + err.toString());
                }
            }
        }
        xmlhttp.send(data);
    }
    catch (e)
    {
        gHeadup.LogError('BeginGetResponse', e);
        var data2 = {};
        data2['responsetext'] = e.message;
        data2['opid'] = opid;
        gHeadup.FireEventInWindow('ErrorInExtension', data2, reciver);
        data2 = null;
        
    }
}


var httpRequestObserver =
{
  observe: function(subject, topic, data)
  {
    if (topic == "http-on-examine-response")
    {
        try
        {
            var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
            //var url = httpChannel.originalURI.spec;
            if (httpChannel != null &&  httpChannel.notificationCallbacks != null && httpChannel.notificationCallbacks.status == 401)
            {
                if (httpChannel.originalURI == null)
                {
                    return;
                }
                else if (httpChannel.originalURI.host.indexOf('friendfeed.com') != -1)
                {
                    // turn off auth window
                    httpChannel.notificationCallbacks = null;
                    return;
                }
                else if (httpChannel.originalURI.host.indexOf('twitter.com') != -1) // in twitter domain
                {
                    if (httpChannel.originalURI.spec.indexOf('/friendships/create/') == -1) // not our follow request
                    {
                        // turn off auth window
                        httpChannel.notificationCallbacks = null;
                    }
                }
            }
        }
        catch(err)
        {
            //gHeadup.LogError('observe', err);
        }
    }
    else if (topic == 'em-action-requested')
    {
         subject.QueryInterface(Components.interfaces.nsIUpdateItem);
         if (subject.id == 'headup@semantinet.com') {
            if (data == "item-uninstalled") {
                gHeadup.DeleteAllPrefs();
                gHeadup.FireEventInSingleWindow('HeadupUninstalled', null);
            }
         }
    }
    
  },

  get observerService() {
    return Components.classes["@mozilla.org/observer-service;1"]
                     .getService(Components.interfaces.nsIObserverService);
  },

  register: function()
  {
    
    //this.observerService.addObserver(this, "http-on-modify-request", false);
    this.observerService.addObserver(this, "http-on-examine-response", false);
    this.observerService.addObserver(this, "em-action-requested", false);
  },

  unregister: function()
  {
    //this.observerService.removeObserver(this, "http-on-modify-request");
    this.observerService.removeObserver(this, "http-on-examine-response");
  }
};