/*********************************************
* This file is responsible for updating the hints text in the statusbar
* @Author: Eylon Yogev
*********************************************/


try {
    HeadupClass.prototype.Freeze = false;

    HeadupClass.prototype.SetStatusLabel = function(text, force, tabid) {
        var win = gHeadup.GetWindowByTabId(tabid);
        gHeadup.InternalSetStatusLabel(text, force, win);
    }

    HeadupClass.prototype.InternalSetStatusLabel = function(text, force, win) {
        try {
            if (!gHeadup.Freeze || force) {
                win.document.getElementById('Keybitz.Labels.StatusLabel').value = text;
            }
        }
        catch (err) {
            gHeadup.LogError('SetStatusLabel', err);
        }
    }

    HeadupClass.prototype.SetStatusCount = function(text, force, tabid) {
        var win = gHeadup.GetWindowByTabId(tabid);
        gHeadup.InternalSetStatusCount(text, force, win);
    }

    HeadupClass.prototype.InternalSetStatusCount = function(text, force, win) {
        try {
            if (!gHeadup.Freeze || force) {
                win.document.getElementById('Keybitz.Labels.HintsCount').value = text;
            }
        }
        catch (err) {
            gHeadup.LogError('SetStatusCount', err);
        }
    }

    HeadupClass.prototype.SetTextFreeze = function(freeze) {
        try {
            gHeadup.Freeze = freeze;
        }
        catch (err) {
            gHeadup.LogError('SetTextFreeze', err);
        }
    }

    HeadupClass.prototype.SetStatusLoading = function(win) {
        try {
            gHeadup.InternalSetStatusLabel('Headup is loading...', false, win);
            gHeadup.InternalSetStatusCount('', false, win);
        }
        catch (err) {
            gHeadup.LogError('SetStatusLoading', err);
        }
    }

    HeadupClass.prototype.SetStatusEmpty = function(win) {
        try {
            gHeadup.InternalSetStatusLabel('', false, win);
            gHeadup.InternalSetStatusCount('', false, win);
        }
        catch (err) {
            gHeadup.LogError('SetStatusEmpty', err);
        }
    }

    HeadupClass.prototype.InternalUpdateHintStatusText = function(text, win) {
        if (text == "0" || text == 'undefined') {
            this.SetStatusEmpty(win);
            return;
        }

        gHeadup.InternalSetStatusLabel('Headup recommends', false, win);
        //gHeadup.InternalSetStatusCount(text, false, win);
    }

    HeadupClass.prototype.UpdateHintStatusText = function(params) {
        try {
            var text = params['text'];
            if (text == 'undefined')
                text = '0';
            var tabid = params['tabid'];
            var win = gHeadup.GetWindowByTabId(tabid);
            gHeadup.SetHintText(text, tabid);
            if (win.gBrowser.selectedBrowser.Guid == tabid) {
                this.InternalUpdateHintStatusText(text, win);
            }
        }
        catch (err) {
            gHeadup.LogError('UpdateHintStatusText', err);
        }
    }

    HeadupClass.prototype.ResetStatus = function() {
        try {
            gHeadup.ForeachWindow(function(win) {
                gHeadup.InternalUpdateHintStatusText("0", win);
            });
        }
        catch (err) {
            gHeadup.LogError('ResetStatus', err);
        }
    }

    HeadupClass.prototype.OnHintsTextClick = function(win, event) {
        var data = {};
        data['tabid'] = win.gBrowser.selectedBrowser.Guid;
        gHeadup.FireEventInSingleWindow('SiteLevelHintsTextClick', data);
    }

    HeadupClass.prototype.ShowHintsNotification = function(tabid, image, title, text, clickable, linkEvent, force) {
        if (gHeadup.Freeze && !force)
            return;
        var listener = null;
        if (clickable) {
            listener = {
                observe:
                function(subject, topic, data) {
                    if (topic == 'alertclickcallback' && data == 'headup') {
                        var win = gHeadup.GetWindowByTabId(tabid);
                        var data = {};
                        data['tabid'] = tabid;
                        data['linkEvent'] = linkEvent;
                        gHeadup.FireEventInSingleWindow('HintsNotificationLink', data);
                    }
                }
            }
        }

        var alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
        alertsService.showAlertNotification(image, title, text, clickable, "headup", listener);
    }


}
catch (err) {
    gHeadup.LogError('error prototyping HintStatus: ' + err);
}