/*********************************************
*
* @Author: Eylon Yogev
*********************************************/

try {

    HeadupClass.prototype.rememberMe = 'true';
    HeadupClass.prototype.InstallationMode = false;
    HeadupClass.prototype.ComputerGuid = null;
    HeadupClass.prototype.PerDownloaded = 0;
    HeadupClass.prototype.browserTab = null;

    HeadupClass.prototype.CloseInstallationPage = function() {
        this.InstallationMode = false;
    }

    HeadupClass.prototype.InternalSetRememberMe = function(newval) {
        this.rememberMe = newval;
    }

    HeadupClass.prototype.SetRememberMe = function(params) {
        InternalSetRememberMe(params['rememberme']);
    }

    HeadupClass.prototype.RunSilverlightInstallation = function() {
        try {
            if (gHeadup.NeedToInstall()) {
                setTimeout(function() {
                    gHeadup.browserTab = gHeadup.OpenAndReturnTab(gHeadup.Consts.InstallingSilverlightURL);
                    gHeadup.WaitForButton(function() {
                        var dom = gHeadup.browserTab.contentDocument;
                        dom.getElementById('restartButton').addEventListener("click", gHeadup.RestartButtonClicked, false);
                        dom.getElementById('btnInstall').addEventListener("click", function() {
                            dom.getElementById('install').style.visibility = 'hidden';
                            dom.getElementById('loader').style.visibility = 'visible';
                            gHeadup.DownloadAndRunInstall(gHeadup.browserTab);
                        }, false);
                    });
                }, 1000);
                return true;
            }

            return false;
        }
        catch (err) {
            gHeadup.LogError('RunSilverlightInstallation', err);
        }
    }

    HeadupClass.prototype.WaitForButton = function(callback) {
        if (gHeadup.browserTab.contentDocument.getElementById('btnInstall') != null)
	{
            callback();
	    return;
	}
        setTimeout(function() {
            gHeadup.WaitForButton(callback);
        }, 300);
    }

    HeadupClass.prototype.MonitorInstallationDone = function() {
        var intervalID = setInterval(function() {
            navigator.plugins.refresh();
            if (gHeadup.IsSilverlightInstalled()) {
                // installing silverlight completed
                clearInterval(intervalID);
                gHeadup.SendStat('1003', '');
            }
        }, 1000);
    }

    HeadupClass.prototype.NeedToInstall = function() {
        try {
            if (gHeadup.IsSilverlightInstalled() == false &&
                gHeadup.GetStringPref('InstallSilverlight') == 'true' &&
                this.HeadupFileExists('once') == false) {

                gHeadup.SetStringPref('InstallSilverlight', 'false');
                gHeadup.WriteSpecialTextFile('once', '');
                return true;
            }
            else {
                return false;
            }
        }
        catch (err) {
            gHeadup.LogError('NeedToInstall', err);
            return false;
        }
    }

    HeadupClass.prototype.RestartButtonClicked = function() {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var mainWindow = wm.getMostRecentWindow("navigator:browser");
            gHeadup.CloseAllInstalltionTabs(mainWindow);
        }
        catch (err) {
        }

        try {
            gHeadup.SendStat('1004', '');
            gHeadup.RestartApp();
        }
        catch (err) {
        }
    }

    HeadupClass.prototype.GetSLEXE = function() {
        if (gHeadup.Platform == 'mac')
            return 'Silverlight.2.0.dmg';
        else
            return 'Silverlight.2.0.exe';
    }


    HeadupClass.prototype.DownloadAndRunInstall = function(browserTab) {
        // send statistic - running installation process
        gHeadup.SendStat('1001', '');
        var url = gHeadup.Consts.SilverlightXPDownloadUrl;
        if (gHeadup.IsMac())
            url = gHeadup.Consts.SilverlightMacDownloadUrl;
        gHeadup.DownloadFile(url, gHeadup.GetSLEXE(),
        function(per) {
            try {
                var dom = browserTab.contentDocument;
                dom.getElementById('per').textContent = per.toString().substring(0, 2);
            }
            catch (err) {
            }
        },
        function() {
            try {
                gHeadup.SendStat('1002', '');
                gHeadup.ShowInstallationText('Installing...');
            }
            catch (err) {
            }
            gHeadup.RunInstallProcess();
        },
        function() {
            try {
                gHeadup.SendStat('1005', 'Error downloading silverlight installation');
                gHeadup.ShowInstallationError();
            }
            catch (err) {
            }
        });

        gHeadup.MonitorInstallationDone();
    }

    HeadupClass.prototype.ShowInstallationError = function() {
        var dom = gHeadup.browserTab.contentDocument;
        dom.getElementById('loader').style.visibility = 'hidden';
        dom.getElementById('install').style.visibility = 'hidden';
        dom.getElementById('problem').style.visibility = 'visible';
    }

    HeadupClass.prototype.ShowInstallationText = function(text) {
        var dom = gHeadup.browserTab.contentDocument;
        dom.getElementById('txtLoading').innerHTML = text;
    }

    HeadupClass.prototype.RunInstallProcess = function() {


        if (gHeadup.Platform == 'mac') {
            // gets the installation file
            var installtionFile = gHeadup.FileSpecialPathToObject(gHeadup.GetSLEXE());

            // simulates double clicking on it. we have a known issue here when the default program that opens .pkg files is not Installer
            gHeadup.RunProcess(installtionFile.path);

            gHeadup.RunPkg(10);
        }
        else {
            var file = gHeadup.FileSpecialPathToObject(gHeadup.GetSLEXE());

            // create an nsIProcess
            var process = Components.classes["@mozilla.org/process/util;1"]
                            .createInstance(Components.interfaces.nsIProcess);
            process.init(file);

            // Run the process.
            // If first param is true, calling thread will be blocked until
            // called process terminates.
            // Second and third params are used to pass command-line arguments
            // to the process.
            var args = ["/q"];
            //var args = [""];
            process.run(false, args, args.length);
        }
    }

    HeadupClass.prototype.RunPkg = function(tries) {
        if (tries == 0) {
            gHeadup.ShowInstallationError();
            return;
        }
        tries--;
        if (gHeadup.RunProcess('/Volumes/Silverlight.2.0/Silverlight.2.0.pkg') == false) {
            setTimeout(function() {
                gHeadup.RunPkg(tries);
            }, 1000);
        }
    }
    
    HeadupClass.prototype.RunProcess = function(filename) {
        try {
            var file = Components.classes["@mozilla.org/file/local;1"]
                         .createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath(filename);
            if (!file.exists())
                return false;
            file.launch();
            return true;
        }
        catch (err) {
            return false;
        }
    }

    HeadupClass.prototype.RestartApp = function() {
        var nsIAppStartup = Components.interfaces.nsIAppStartup;

        // Notify all windows that an application quit has been requested.
        var os = Components.classes["@mozilla.org/observer-service;1"]
                     .getService(Components.interfaces.nsIObserverService);
        var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
                             .createInstance(Components.interfaces.nsISupportsPRBool);
        os.notifyObservers(cancelQuit, "quit-application-requested", null);

        // Something aborted the quit process. 
        if (cancelQuit.data)
            return;

        // Notify all windows that an application quit has been granted.
        os.notifyObservers(null, "quit-application-granted", null);

        // Enumerate all windows and call shutdown handlers
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);
        var windows = wm.getEnumerator(null);
        while (windows.hasMoreElements()) {
            var win = windows.getNext();
            if (("tryToClose" in win) && !win.tryToClose())
                return;
        }
        Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup)
            .quit(nsIAppStartup.eRestart | nsIAppStartup.eAttemptQuit);
    }

    HeadupClass.prototype.OpenGetStartedPage = function() {
        try {
            gHeadup.OpenUrlInInstalltaionTab(gHeadup.Consts.GetStartedURL);
        }
        catch (err) {
            gHeadup.LogError('OpenGetStartedPage', err);
        }
    }

    HeadupClass.prototype.HeadupPageOpenSettings = function() {
        var data = {};
        data['id'] = 'charm-menuitem-Settings';
        data['text'] = 'Settings';
        gHeadup.FireEventInSingleWindow('ToggleMenuItemChosen', data);
    }

    HeadupClass.prototype.OpenUrlInInstalltaionTab = function(url) {
        try {

            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var mainWindow = wm.getMostRecentWindow("navigator:browser");
            gHeadup.CloseAllInstalltionTabs(mainWindow);
            mainWindow.gBrowser.selectedTab = mainWindow.gBrowser.addTab(url);
        }
        catch (err) {
            gHeadup.LogError('OpenUrlInInstalltaionTab', err);
        }
    }

    HeadupClass.prototype.OpenAndReturnTab = function(url) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var mainWindow = wm.getMostRecentWindow("navigator:browser");
            gHeadup.CloseAllInstalltionTabs(mainWindow);
            var tab = mainWindow.gBrowser.addTab(url);
            mainWindow.gBrowser.selectedTab = tab;
            return mainWindow.gBrowser.getBrowserForTab(tab);
        }
        catch (err) {
            gHeadup.LogError('OpenAndReturnTab', err);
        }
    }

    HeadupClass.prototype.CloseAllInstalltionTabs = function(win) {
        gHeadup.TryCloseTab(gHeadup.Consts.NoPluginPage, win);
        gHeadup.TryCloseTab(gHeadup.Consts.PluginIsInstalledPage, win);
        gHeadup.TryCloseTab(gHeadup.Consts.LoadingURL, win);
        gHeadup.TryCloseTab(gHeadup.Consts.InstallingSilverlightURL, win);
    }

    HeadupClass.prototype.TryCloseTab = function(url, win) {
        var tab = gHeadup.FindTabByURL(url, win);
        if (tab != null) {
            win.gBrowser.removeTab(tab);
        }
    }


    HeadupClass.prototype.S4 = function() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    HeadupClass.prototype.CreateNewGuid = function() {
        var sb = new StringBuffer();
        sb.append(gHeadup.S4());
        sb.append(gHeadup.S4());
        sb.append("-");
        sb.append(gHeadup.S4());
        sb.append("-");
        sb.append(gHeadup.S4());
        sb.append("-");
        sb.append(gHeadup.S4());
        sb.append("-");
        sb.append(gHeadup.S4());
        sb.append(gHeadup.S4());
        sb.append(gHeadup.S4());
        return sb.toString();
    }

    HeadupClass.prototype.InitComputerGuid = function() {
        gHeadup.ComputerGuid = gHeadup.GetStringPref('ComputerGuid');
        if (gHeadup.ComputerGuid == null || gHeadup.ComputerGuid == '') {
            gHeadup.ComputerGuid = gHeadup.CreateNewGuid();
            gHeadup.SetStringPref('ComputerGuid', gHeadup.ComputerGuid);
        }
    }

    HeadupClass.prototype.SendStat = function(operation, comment) {
        try {
            return;
            var sb = new StringBuffer();
            sb.append('INSTALLATION;');
            sb.append(gHeadup.ComputerGuid);
            sb.append(';');
            sb.append(operation);
            sb.append(';');
            var d = new Date();
            sb.append(d.toUTCString());
            sb.append(';');
            sb.append(comment);
            gHeadup.SendUrlData(gHeadup.Consts.StatisticsServiceUrl, sb.toString());
        }
        catch (err) {
            gHeadup.LogError('SendStat', err);
        }
    }

    HeadupClass.prototype.SendFirstStat = function() {
        var firstLoaded = gHeadup.GetStringPref('FirstLoaded2');
        if (firstLoaded == 'false') {
            var sb = new StringBuffer();
            sb.append(gHeadup.GetPlatform());
            sb.append('|');
            sb.append(gHeadup.IsSilverlightInstalled());
            sb.append('|');
            sb.append(gHeadup.Consts.Version);
            gHeadup.SendStat('1000', sb.toString());
        }
    }

    HeadupClass.prototype.SendUrlData = function(url, data) {
        try {
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.overrideMimeType('text/xml');

            xmlhttp.onreadystatechange = function() {
                if (xmlhttp.readyState == 4) {
                    // statistic sent
                }
            }

            xmlhttp.open('POST', url, true);
            xmlhttp.send(data);
        }
        catch (err) {
            gHeaudup.LogError('SendUrlData', err);
        }
    }

    HeadupClass.prototype.DownloadFile = function(url, filePath, progress, done, error) {
        var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                .createInstance(Components.interfaces.nsIWebBrowserPersist);
        // download destination
        var file = gHeadup.FileSpecialPathToObject(filePath);
        try {
            if (file.exists())
                file.remove(false);
        }
        catch (err) {
        }
        var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
                .getService(Components.interfaces.nsIIOService)
                .newURI(url, null, null);
        persist.progressListener = {
            onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
                var percentComplete = (aCurTotalProgress / aMaxTotalProgress) * 100;
                if (percentComplete > gHeadup.PerDownloaded + 1 || percentComplete == 100) {
                    gHeadup.PerDownloaded = percentComplete;
                    if (progress != null)
                        progress(percentComplete);
                }
            },
            onStateChange: function(aWebProgress, aRequest, aStatus, aMessage) {
                if (done != null && aStatus == 327696) {
                    if (gHeadup.PerDownloaded != 100)
                        error();
                    else
                        done();
                }
            }
        }
        persist.saveURI(obj_URI, null, null, null, "", file);
    }

}
catch (err) {
    gHeadup.LogError('error prototyping Installation: ' + err);
}