/*********************************************
* This file is responisble of writing logs to the Error Console and alerting error.
* @Author: Eylon Yogev
*********************************************/

    HeadupClass.prototype.LogWindow = null;
    HeadupClass.prototype.ErrorConsole = null;

    HeadupClass.prototype.LogMsg = function(msg) {
        this.AddLogToLogWindow(msg);
    }

    HeadupClass.prototype.LogError = function(method, msg) {
        if (gHeadup.Consts.ShowAlerts) {
            var longmsg = 'Error in ' + method + ':\n\n' + msg;
            alert(longmsg);
        }
        this.AddLogToLogWindow(longmsg);
    }

    HeadupClass.prototype.AddLogToLogWindow = function(msg) {
        if (gHeadup.Consts.UseErrorConsole) {
            if (this.ErrorConsole == null)
                this.ErrorConsole = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
            this.ErrorConsole.logStringMessage(msg);
        }
    }

    HeadupClass.prototype.SilverLog = function(params) {
        this.AddLogToLogWindow(params['msg']);
    }


    //    * aMessage ? the string to be logged. You must provide this.
    //    * aSourceName ? the URL of file with error. This will be a hyperlink in the JavaScript Console, so you'd better use real URL. You may pass null if it's not applicable.
    //    * aSourceLine ? the line #aLineNumber from aSourceName file. You are responsible for providing that line. You may pass null if you are lazy; that will prevent showing the source line in JavaScript Console.
    //    * aLineNumber and aColumnNumber ? specify the exact location of error. aColumnNumber is used to draw the arrow pointing to the problem character.
    //    * aFlags ? one of flags declared in nsIScriptError. At the time of writing, possible values are: nsIScriptError.errorFlag = 0, nsIScriptError.warningFlag = 1, nsIScriptError.exceptionFlag = 2 and nsIScriptError.strictFlag = 4.
    //    * aCategory ? a string indicating what kind of code caused the message. There are quite a few category strings and they don't seem to be listed in a single place. Hopefully, they will all be listed in nsIScriptError.idl eventually.

    HeadupClass.prototype.myLogToConsole = function(aMessage, aSourceName, aSourceLine, aLineNumber,
                        aColumnNumber, aFlags, aCategory) {
        if (this.ErrorConsole == null)
            this.ErrorConsole = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
        var scriptError = Components.classes["@mozilla.org/scripterror;1"]
                              .createInstance(Components.interfaces.nsIScriptError);
        scriptError.init(aMessage, aSourceName, aSourceLine, aLineNumber,
                   aColumnNumber, aFlags, aCategory);
        this.ErrorConsole.logMessage(scriptError);
    }

    HeadupClass.prototype.WriteFullLog = function(params) {
        var aMessage = params['msg'];
        var aSourceName = params['source'];
        var aSourceLine = params['sourceline'];
        var aLineNumber = params['linenumber'];
        var aColumnNumber = params['columnnumber'];
        var aFlags = params['flags'];
        var aCategory = params['catagory'];
        this.myLogToConsole(aMessage, aSourceLine, aSourceLine, aLineNumber, aColumnNumber, aFlags, aCategory);
    }
