/*********************************************
*
* @Author: Eylon Yogev
*********************************************/

try {
    HeadupClass.prototype.prefsService = null;
    HeadupClass.prototype.prefs = null;

    HeadupClass.prototype.LoadSettings = function() {
        if (this.prefs == null) {
            // Get the "extensions.HeadUp." branch
            this.prefsService = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefService);
            this.prefs = this.prefsService.getBranch("extensions.HeadUp.");
        }
    }

    HeadupClass.prototype.GetStringPref = function(name) {
        try {
            this.LoadSettings();
            var value = this.prefs.getCharPref(name); // get a pref
            return value;
        }
        catch (e) {
            return null;
            gHeadup.LogError('GetStringPref', e);
        }
    }

    HeadupClass.prototype.SetStringPref = function(name, value) {
        try {
            this.LoadSettings();
            this.prefs.setCharPref(name, value); // set a pref
            this.SavePrefs();
        }
        catch (e) {
            gHeadup.LogError('SetStringPref', e);
        }
    }

    HeadupClass.prototype.SilverGetPref = function(params) {
        var name = params['name'];
        return this.GetStringPref(name);
    }

    HeadupClass.prototype.SilverSetPref = function(params) {
        var name = params['name'];
        var value = params['value'];
        this.SetStringPref(name, value);
    }

    HeadupClass.prototype.SavePrefs = function(params) {
        if (this.prefsService == null) {
            this.prefsService = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefService);
        }
        this.prefsService.savePrefFile(null);
    }

    HeadupClass.prototype.DeleteAllPrefs = function(params) {
        try {
            var prefs = Components.classes["@mozilla.org/preferences-service;1"]
              .getService(Components.interfaces.nsIPrefService);
            prefs = prefs.getBranch('extensions.HeadUp.');
            prefs.deleteBranch('');
        }
        catch (err) {
        }
    }

}
catch (err) {
    gHeadup.LogError('error prototyping Settings: ' + err);
}