/*********************************************
* The holly single engine file. This is the main file of the extension. 
* @Author: Eylon Yogev
*********************************************/

try {
    // init this variable to be just window because now the code sits right in the single engine's xuls.
    HeadupClass.prototype.SingleEngineWindow = window;

    // a general guid generator for the extension
    HeadupClass.prototype.operationId = 9990;

    // a reference to the silverlight's callback method
    HeadupClass.prototype.headups = [];

    HeadupClass.prototype.headup = null;

    HeadupClass.prototype.isClosed = false;

    // holds if the extension is inited or not. will be true when the silverlight is loaded and sets
    // this to true using the ExtensionEngineInited method
    HeadupClass.prototype.bExtensionEngineInited = false;
    HeadupClass.prototype.isFocused = false;
    
    HeadupClass.prototype.bridgeInited = false;

    HeadupClass.prototype.GetNextOperationId = function() {
        this.operationId++;
        return this.operationId;
    }

    // This function is called when a new firefox window is opened.
    // If this is the first window then we load the single engine.
    HeadupClass.prototype.SingleWindowLoaded = function() {
        try {
            // the single window is loaded so we are enabled
            gHeadup.isExtensionEnabled = true;
            gHeadup.SetStringPref(gHeadup.Consts.EnabledPref, 'true');
            // set opening status
            gHeadup.SetStatusLoading(window.opener);
            // inits all needed componens. if we have failure (silverlight not installed) we return.
            if (gHeadup.LoadInits() == false)
                return;
            // ok, we are ready lets load!
            gHeadup.FirstInit();

            //if (gHeadup.IsNewVersion()) {
                //gHeadup.OpenNewTab(gHeadup.Consts.ReleaseNotesUrl, false);
            //}

            gHeadup.SendStatOnErrorLoading();
        }
        catch (err) {
            gHeadup.LogError('SingleWindowLoaded', err);
        }
    }

    HeadupClass.prototype.SendStatOnErrorLoading = function() {
        var oneMinute = 1000 * 30;
        setTimeout(function() {
            if (gHeadup.bExtensionEngineInited == false) {
                gHeadup.SendStat('1006', 'extension is not inited!');
            }
        }, oneMinute);
    }

    // register's a new window so we can handle its events too. init its tabs,
    // register to its events and inits its statusbar.
    HeadupClass.prototype.RegisterNewWindow = function(win, force) {
        try {
            if (win.gBrowser == null)
                return;
                
            if (gHeadup.bExtensionEngineInited || force) {
                // sets the window's guid
                win.gHeadup.Guid = gHeadup.NextGuid();

                // init all windows tabs
                gHeadup.InitWindowTabs(win);

                // inits the window's statusbar
                gHeadup.InitStatusbar(win);

                // resiter to window's events
                win.gHeadup.RegisterToEvents();

                // set the this window has been charmed.
                win.gHeadup.inited = true;
            }
        }
        catch (err) {
            gHeadup.LogError('RegisterNewWindow', err);
        }
    }

    // event when the single window got focus
    HeadupClass.prototype.OnSingleWindowFocus = function(event) {
        if (gHeadup.isFocused == false) {
            gHeadup.isFocused = true;
        }
    }

    // event when the single window lost focus
    HeadupClass.prototype.OnSingleWindowBlur = function(event) {
        try {
            if (gHeadup.isFocused == true) {
                gHeadup.isFocused = false;

                if (gHeadup.IsMac()) {
                    //this.MinimizeSingleWindow();
                }
                else {
                    // hide the single window only if no one is focused
                    gHeadup.HideIfNotFocused();
                }
            }
        }
        catch (err) {
            //gHeadup.LogError('OnSingleWindowBlur', err);
        }
    }

    HeadupClass.prototype.isBluring = false;

    HeadupClass.prototype.MinimizeSingleWindow = function() {
        if (this.isBluring == false) {
            this.isBluring = true;
            // set timer
            setTimeout(function() {
                var tab = gHeadup.GetActiveTab();
                if (gHeadup.isFocused == false && tab.SWShown == true) {
                    window.focus();
                    window.minimize();
                    gHeadup.CloseBluringInTimeout();
                }
                else {
                    gHeadup.isBluring = false;
                }
            }, 0);
        }
    }

    HeadupClass.prototype.CloseBluringInTimeout = function() {
        setTimeout(function() {
            gHeadup.isBluring = false;
        }, 1000);
    }

    // hides the single window only if no other window is in focus.
    // it doesn't this after a timer of o seconds. why you ask? because this way we let a potential
    // focus event on another window accur first so the focus check will be real
    HeadupClass.prototype.HideIfNotFocused = function() {
        // set timer
        setTimeout(function() {
            // if no one is focues hide the single window
            if (gHeadup.IsAnyoneFocused() == false)
                gHeadup.InternalHideSingleWindow();
        }, 0);
    }

    // checks to see if any of the opened windows are in focus
    HeadupClass.prototype.IsAnyoneFocused = function() {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = wm.getEnumerator(null);
        // foreach opened window
        while (enumerator.hasMoreElements()) {
            var win = enumerator.getNext();
            // if we found an opened window, return true
            if (win.gHeadup && win.gHeadup.isFocused == true)
                return true;
        }

        // no open windows, return false
        return false;
    }

    // event when a firefox window gets focus
    HeadupClass.prototype.OnWindowFocus = function(win) {
        try {
            if (win == null || win.gBrowser.selectedBrowser.Win == null || gHeadup.IsMac()) {
                return;
            }

            // make it like he switched tab so we will restore the window on the active tab.
            this.SwitchToTab(win.gBrowser.selectedBrowser);
        }
        catch (err) {
            gHeadup.singleWindow.gHeadup.LogError('OnWindowFocus', err);
        }
    }

    // events when a firefox window lost focus
    HeadupClass.prototype.OnWindowBlur = function(win) {
        try {
            if (this.IsMac() == false) {
                // if no one is focued, hide the single window
                this.HideIfNotFocused();
            }
        }
        catch (err) {
            gHeadup.singleWindow.gHeadup.LogError('OnWindowBlur', err);
        }
    }

    // switch to a tab. when the user switches to a tab we need to check if there is a headup opened there
    // and if so restore and show the single window
    HeadupClass.prototype.SwitchToTab = function(tab) {
        try {
            // if this tab has headup window shown on it
            if (tab.SWShown) {

                // tell the silverlight to change the view
                var data = {};
                data['tabid'] = gHeadup.GetTabGuid(tab);
                this.FireEventInSingleWindow("TabSelected", data);

                // show the single window
                this.ShowSingleWindow(tab);
                this.MacFocus();
            }
            else {
                // no shown on tab, just hide it
                if (tab.Guid != null)
                    this.HideSingleWindow(tab.Guid);
            }

            // update the text in the hints statusbar
            gHeadup.InternalUpdateHintStatusText(tab.HintText, tab.Win);
        }
        catch (err) {
            gHeadup.LogError('SwitchToTab', err);
        }
    }

    // inits all tabs in a window.
    HeadupClass.prototype.InitWindowTabs = function(win) {
        var num = win.gBrowser.browsers.length;
        for (var i = 0; i < num; i++) {
            try {
                gHeadup.InitTab(win.gBrowser.getBrowserAtIndex(i), win);
            }
            catch (err) {
                gHeadup.LogError('InitWindowTabs', err);
            }
        }
    }

    // this method is called from the silverlight to tell the extension that it has loaded and
    // inited and ready to rock!
    HeadupClass.prototype.ExtensionEngineInited = function(params) {
        try {
            // restore the focus to the main firefox window on mac. No need on PC.
            this.MacRestoreFocus();

            // register all already opened windows.
            this.ForeachWindow(function(win) {
                try {
                    if (!win.gHeadup)
                        win.gHeadup = new HeadupClass();
                    win.gHeadup.isExtensionEnabled = true;
                    win.gHeadup.singleWindow = window;
                    gHeadup.RegisterNewWindow(win, true);
                }
                catch (err) {
                    gHeadup.LogError('ForeachWindow - RegisterNewWindow', err);
                }
            });

            // fire the page loaded event for each opened tab.
            this.ForeachTab(function(tab) {
                try {
                    var doc = tab.contentDocument;
                    if (doc != null) {
                        gHeadup.FirePageLoadedEvent(doc);
                    }
                }
                catch (err) {
                    gHeadup.LogError('ForeachWindow - FirePageLoadedEvent', err);
                }
            });

            // make the single window draggable
            gHeadup.MakeWindowDraggable();

            // done with all inits. set that the extension is ready.
            this.bExtensionEngineInited = true;
        }
        catch (err) {
            gHeadup.LogError('ExtensionEngineInited', err);
        }
    }

    HeadupClass.prototype.MacRestoreFocus = function() {
        try {
            window.opener.focus();
        }
        catch (err) {
            gHeadup.LogError('MacRestoreFocus', err);
        }
    }

    // invode a action for each opened window
    HeadupClass.prototype.ForeachWindow = function(action) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var enumerator = wm.getEnumerator(null);
            while (enumerator.hasMoreElements()) {
                var win = enumerator.getNext();
                if (win.location != gHeadup.Consts.SingleEngineChromPath) {
                    action(win);
                }
            }
        }
        catch (err) {
            gHeadup.LogError('ForeachWindow', err);
        }
    }

    // invoke a method for each tab opened in each firfox window
    HeadupClass.prototype.ForeachTab = function(action) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var enumerator = wm.getEnumerator(null);
            while (enumerator.hasMoreElements()) {
                var win = enumerator.getNext();
                if (win.location != gHeadup.Consts.SingleEngineChromPath) {
                    if (win.gBrowser != null) {
                        var num = win.gBrowser.browsers.length;
                        for (var i = 0; i < num; i++) {
                            action(win.gBrowser.getBrowserAtIndex(i));
                        }
                    }
                }
            }
        }
        catch (err) {
            gHeadup.LogError('ForeachTab', err);
        }
    }

    // focuses the single window
    HeadupClass.prototype.FocusSingleWindow = function(onlyOnMac) {
        if (onlyOnMac == false || gHeadup.Platform == 'mac')
            window.focus();
    }

    // fires an event in the singel window.
    HeadupClass.prototype.FireEventInSingleWindow = function(topic, data) {
        if (data == null)
            data = {};
        data['topic'] = topic;

        if (gHeadup.SingleEngineWindow == null)
            return;

        if (gHeadup.headup != null && gHeadup.bridgeInited)
            gHeadup.headup.ExtensionMethod(data);
    }

    HeadupClass.prototype.FireEventInWindow = function(topic, data, name) {
        if (data == null)
            data = {};
        data['topic'] = topic;

        if (this.SingleEngineWindow == null)
            return;

        if (gHeadup.headups[name] != null && gHeadup.bridgeInited)
            gHeadup.headups[name].ExtensionMethod(data);
    }

    HeadupClass.prototype.FireEventInAllWindows = function(topic, data) {
        if (data == null)
            data = {};
        data['topic'] = topic;

        for (var name in gHeadup.headups) {
            gHeadup.FireEventInWindow(topic, data, name);
        }
    }

    // sets the headup bridge. this is the magic that lets us call a silverlight callback from javascript
    HeadupClass.prototype.SetHeadupBridge = function(name) {
        try {
            if (name == 'Extension') {
                gHeadup.headups[name] = content.wrappedJSObject.headup;
                gHeadup.headup = gHeadup.headups[name];
                gHeadup.bridgeInited = true;
            }
            else {
                gHeadup.headups[name] = gHeadup.myHeadupWindows[name].content.wrappedJSObject.headup;
            }
        }
        catch (err) {
            gHeadup.LogError('SetHeadupBridge', err);
        }
    }

    // returns a object with positionind data of the window contaning the tabid
    HeadupClass.prototype.GetWindowPositionData = function(tabid) {
        var win = gHeadup.GetWindowByTabId(tabid);

        var o = new Object();
        o.screenX = win.screenX;
        o.screenY = win.screenY;
        o.innerWidth = win.innerWidth;
        o.innerHeight = win.innerHeight;
        o.contentInnerWidth = win.content.innerWidth;
        o.contentInnerHeight = win.content.innerHeight;
        o.scrollX = win.content.scrollX;
        o.scrollY = win.content.scrollY;
        o.scrollbars = win.scrollbars.visible;
        o.resolutionWidth = screen.width;
        o.resolutionHeight = screen.height;
        return o;
    }
    
    // opens the single window in the given x, y in a specific tab
    // this method is called from the silverlight
    HeadupClass.prototype.OpenSingleWindow = function(width, height, x, y, tabid) {
        try {
            gHeadup.SaveSingleWindowData(x, y, width, height, tabid);
            this.InternalSetSingleWindowSize(width, height, tabid, 'HeightThenWidth');

            var win = gHeadup.GetWindowByTabId(tabid);
            if (tabid == win.gBrowser.selectedBrowser.Guid) {
                this.InternalMoveSingleWindow(x, y);
                this.SingleEngineWindow.focus();
            }
        }
        catch (err) {
            gHeadup.LogError('OpenSingleWindow', err);
        }
    }

    // an in internal method for changing the single windows size on a specific tab
    HeadupClass.prototype.InternalSetSingleWindowSize = function(Width, Height, tabid, animation) {
        try {
            gHeadup.UpdateSizeData(Width, Height, tabid);
            var win = gHeadup.GetWindowByTabId(tabid);
            if (tabid == win.gBrowser.selectedBrowser.Guid) {

                if (animation == 'height_then_width_obs')
                    gHeadup.AnimateHeightThenWidth(Width, Height);
                else
                    this.SingleEngineWindow.resizeTo(Width, Height);
            }
        }
        catch (err) {
            gHeadup.LogError('InternalSetSingleWindowSize', err);
        }
    }

    // internaly hide the single window.
    HeadupClass.prototype.InternalHideSingleWindow = function() {
        this.SingleEngineWindow.resizeTo(2, 2);
        this.SingleEngineWindow.moveTo(4000, 4000);
    }

    // silverlight api to hide the single window.
    HeadupClass.prototype.HideSingleWindow = function(tabid) {
        try {
            // get the tab
            var tab = gHeadup.GetTabByTabId(tabid);
            if (tab == null)
                return;

            // mark that the window is no longer shown on this tab
            gHeadup.MarkShownOnTab(tab, false);

            // check if the user is viewing the tab we are hiding
            var win = gHeadup.GetWindowByTabId(tabid);
            if (tabid == win.gBrowser.selectedBrowser.Guid) {
                // hide the window
                this.InternalHideSingleWindow();
            }
        }
        catch (e) {
            gHeadup.LogError('HideSingleWindow', e);
        }
    }

    // shows the single window. restores it size and potision.
    HeadupClass.prototype.ShowSingleWindow = function(tab) {
        this.InternalSetSingleWindowSize(tab.SWWidth, tab.SWHeight, tab.Guid, null);
        this.InternalMoveSingleWindow(tab.SWX, tab.SWY);
    }

    // internal method to move the single window
    HeadupClass.prototype.InternalMoveSingleWindow = function(x, y) {
        this.SingleEngineWindow.moveTo(x, y);
    }

    // closes the single window. resets all status bar to be empty.
    HeadupClass.prototype.CloseSingleEngine = function(closeImmediatlly) {

        gHeadup.InternalHideSingleWindow();
        gHeadup.ForeachWindow(function(win) {
            gHeadup.SetStatusEmpty(win);
            win.gHeadup.singleWindow = null;
        });

        gHeadup.isClosed = true;
        gHeadup.SingleEngineWindow.content.src = 'about:blank';
        if (closeImmediatlly)
            gHeadup.HardCloseWindow();
        else
            setTimeout(gHeadup.HardCloseWindow, 1000);
    }

    HeadupClass.prototype.HardCloseWindow = function() {
        gHeadup.SingleEngineWindow.close();
        gHeadup.SingleEngineWindow = null;
        gHeadup = new HeadupClass();
    }

    // fires a page loaded event of given page.
    HeadupClass.prototype.FirePageLoadedEvent = function(page, winID) {
        var domain = this.GetSafeLocation(page);
        var tabid = page.Tab.Guid;
        var title = page.title;
        var data = {};
        data['domain'] = domain;
        data['tabid'] = tabid;
        data['title'] = title;
        data['docid'] = page.Guid;
        data['winid'] = winID;

        this.FireEventInSingleWindow('PageLoaded', data);
    }

    // saftly get tht location
    HeadupClass.prototype.GetSafeLocation = function(page) {
        try {
            return page.location.href;
        }
        catch (err) {
            return '';
        }
    }

    // changes the height of the single window on a given tab
    HeadupClass.prototype.SetHeight = function(height, tabid, animation) {
        try {
            this.InternalSetSingleWindowSize(this.SingleEngineWindow.outerWidth, height, tabid, animation);
        }
        catch (err) {
            gHeadup.LogError('SetHeight', err);
        }
    }

    HeadupClass.prototype.IsMouseDown = function(tabid) {
        var win = gHeadup.GetWindowByTabId(tabid);
        if (win != null)
            return win.gHeadup.isMouseDown;
        else
            return false;
    }

    HeadupClass.prototype.FocusRecenWindow = function() {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var mainWindow = wm.getMostRecentWindow("navigator:browser");
            mainWindow.focus();
        }
        catch (err) {
            gHeadup.LogError('FocusRecenWindow', err);
        }
    }

    HeadupClass.prototype.MacFocus = function() {
        if (gHeadup.Platform == 'mac')
            window.focus();
    }

}
catch (err) {
    gHeadup.LogError('error prototyping SingleEngine: ' + err);
}
