/*********************************************
*
* @Author: Eylon Yogev
*********************************************/

    HeadupClass.prototype.isExtensionEnabled = true;
    HeadupClass.prototype.enableStatusbarIcon = null;
    HeadupClass.prototype.isRegularIcon = true;
    HeadupClass.prototype.iconStick = false;

    HeadupClass.prototype.OnStatusClick = function(win, event) {
        try {
            var btnCode = event.button;

            switch (btnCode) {
                case 0: this.LeftButtonClicked(win); // left button clicked
                    break;

                case 2: this.RightButtonClicked(win, event); // right button clicked
                    break;

                default: break;
            }
        }
        catch (err) {
            gHeadup.LogError('OnStatusClick', err);
        }
    }

    HeadupClass.prototype.InitStatusbar = function(win) {
        this.RemoveUnusedMenus(win);
        this.InitContextFromMainWindow(win);
    }

    HeadupClass.prototype.InitContextFromMainWindow = function(win) {
        var mainWindow = null;
        gHeadup.ForeachWindow(function(currentWin) {
            if (currentWin.gHeadup && currentWin.gHeadup.inited == true && currentWin != win)
                mainWindow = currentWin;
        });

        if (mainWindow == null)
            return;

        var mainMenu = mainWindow.document.getElementById('charm-main-menupopup');
        var newMenu = win.document.getElementById('charm-main-menupopup');
        for (var i = 0; i < mainMenu.childNodes.length; i++) {
            var mainChild = mainMenu.childNodes[i];
            var newChild = newMenu.childNodes[i];
            newChild.label = mainChild.label;
            // changed from newChild.disable to current line because it dosen't work on ff 2.
            newChild.setAttribute('disabled', mainChild.getAttribute('disabled'));
        }
    }

    HeadupClass.prototype.RemoveUnusedMenus = function(win) {
        try {
            var charmMenu = win.document.getElementById('charm-main-menupopup');
            var bringToFrontItem = win.document.getElementById('charm-menuitem-BringToFront');
            var showDebugItem = win.document.getElementById('charm-menuitem-ShowDebugScreen');

            if (gHeadup.Platform == 'mac') {

                // show the bring to front menu item
                bringToFrontItem.hidden = false;
            }
            else {
                bringToFrontItem.hidden = true;
            }

            var dbg = (gHeadup.GetStringPref(gHeadup.Consts.DebugPref) == 'true')
            if (dbg) {
                showDebugItem.hidden = false;
            }
            else {
                showDebugItem.hidden = true;
            }
        }
        catch (err) {
            gHeadup.LogError('InitContextMenu', err);
        }
    }

    HeadupClass.prototype.LeftButtonClicked = function(win) {
        if (gHeadup.Platform == 'mac') {
            if (GetShownOnTab(win.gBrowser.selectedBrowser) == true) {
                gHeadup.FocusSingleWindow(false);
            }
        }
        else {
            // open context menu
            var element = win.document.getElementById("keybitz.enable.icon");
            var charmMenu = win.document.getElementById('charm-main-menupopup');
            charmMenu.showPopup(element, element.boxObject.screenX, element.boxObject.screenY, "popup", "none", "none");
        }
    }

    HeadupClass.prototype.RightButtonClicked = function(win, mouseEvent) {
        if (mouseEvent.ctrlKey == true && mouseEvent.altKey == true) {
            var data = {};
            data['winid'] = win.Guid;
            gHeadup.FireEventInSingleWindow('DebugWindowChosen', data);
        }

    }

    HeadupClass.prototype.ToggleMenuItemChosen = function(win, event) {
        var data = {};
        data['id'] = event.target.id;
        data['text'] = event.target.label;
        data['winid'] = win.Guid;
        gHeadup.FireEventInAllWindows('ToggleMenuItemChosen', data);
    }

    HeadupClass.prototype.BringHeadupToFront = function(winid) {
        var win = gHeadup.GetWindowByWinId(winid);
        if (GetShownOnTab(win.gBrowser.selectedBrowser) == true) {
            gHeadup.FocusSingleWindow(false);
        }
    }

    HeadupClass.prototype.ChangeHeadupStatus = function(event) {
        try {
            if (gHeadup.isSilverlightInstalled == false) {
                gHeadup.InternalGotoURLInActiveTab(gHeadup.Consts.NoPluginPage);
                return;
            }

            if (gHeadup.isExtensionEnabled) {
                gHeadup.SetDisabled(true);
            }
            else {
                gHeadup.SetEnabled();
            }
        }
        catch (err) {
        }
    }

    HeadupClass.prototype.IsLoggedIn = function() {
        return gHeadup.GetStringPref(gHeadup.Consts.RememberMePref) == 'true';
    }

    HeadupClass.prototype.Login = function() {
        this.SetEnabled();
    }

    HeadupClass.prototype.ChangeMenuItemProperty = function(itemid, name, value) {
        gHeadup.ForeachWindow(function(win) {
            var element = win.document.getElementById(itemid);
            if (element != null)
                element.setAttribute(name, value);
        });
    }

    HeadupClass.prototype.SetEnabled = function() {
        try {
//            gHeadup.ForeachWindow(function(win) {
//                win.gHeadup.RegisterToEvents();
//                win.gHeadup.SetEnableDisableIcon(true);
//            });
            gHeadup.isExtensionEnabled = true;

            gHeadup.SetEnableStateToFile(true);
            gHeadup.FirstInit();
            //this.CallDomLoadedForAllTabs();

            setTimeout(function() {
                var data = {};
                data['enabled'] = true;
                gHeadup.FireEventInSingleWindow('SetEnable', data);
            }, 2000);

        }
        catch (err) {
            gHeadup.LogError('Error in SetEnable', err);
        }
    }

    HeadupClass.prototype.SetDisabled = function(closeImmediatlly) {
        try {
            gHeadup.CloseAllXulWindows();
            gHeadup.InternalHideSingleWindow();
            gHeadup.SetStringPref(gHeadup.Consts.EnabledPref, 'false');
            var data = {};
            data['enabled'] = false;
            gHeadup.FireEventInSingleWindow('SetEnable', data);

            gHeadup.ForeachWindow(function(win) {
                gHeadup.SetStatusEmpty(win);
                win.gHeadup.DetachEvents();
                win.gHeadup.SetEnableDisableIcon(false);
            });
            gHeadup.isExtensionEnabled = false;

            gHeadup.CloseSingleEngine(closeImmediatlly);
        }
        catch (err) {
            gHeadup.LogError('Error in SetDisabled', err);
        }
    }



    HeadupClass.prototype.SetToolTip = function(win, text) {
        win.document.getElementById('keybitz.enable.icon').setAttribute('tooltiptext', text);
    }

    HeadupClass.prototype.SetEnableImage = function(win, image) {
        win.document.getElementById('keybitz.enable.icon').setAttribute('src', image);
    }

    HeadupClass.prototype.SetEnableStateToFile = function(trueOrFalse) {
        gHeadup.SetStringPref(gHeadup.Consts.EnabledPref, trueOrFalse.toString());
    }

    HeadupClass.prototype.CallDomLoadedForAllTabs = function() {
        try {
            gHeadup.ForeachWindow(function(win) {
                gHeadup.InitWindowTabs(win);
            });

            gHeadup.ForeachWindow(function(win) {
                var num = win.gBrowser.browsers.length;
                for (var i = 0; i < num; i++) {
                    var curTab = win.gBrowser.getBrowserAtIndex(i);
                    try {

                        if (curTab.contentDocument != null)
                            gHeadup.FirePageLoadedEvent(curTab.contentDocument);
                    }
                    catch (err) {
                    }
                }
            });
        }
        catch (err) {
            gHeadup.LogError('CallDomLoadedForAllTabs', err);
        }
    }

    HeadupClass.prototype.OnStatusOver = function(win, event) {
        if (this.isRegularIcon == true)
            this.SetEnableImage(win, gHeadup.Consts.OnoverIconPath);
        win.setCursor('pointer');
    }

    HeadupClass.prototype.OnStatusOut = function(win, event) {
        if (this.isRegularIcon == true)
            win.gHeadup.SetEnableDisableIcon(this.isExtensionEnabled);
        win.setCursor('default');
    }

    HeadupClass.prototype.ChangeStatusbarIcon = function(image, tooltip, stick, tabid) {
        if (this.iconStick == true)
            return;
        this.isRegularIcon = false;

        var win = gHeadup.GetWindowByTabId(tabid);
        this.SetEnableImage(win, 'chrome://keybitz/skin/' + image);
        if (tooltip != null && tooltip != '')
            this.SetToolTip(win, tooltip);

        if (stick == true)
            this.iconStick = true;
    }

    HeadupClass.prototype.RestoreRegularIcon = function(releasestick, tabid) {
        try {
            if (this.iconStick == true && releasestick == true)
                return;

            this.iconStick = false;
            this.isRegularIcon = true;
            var win = gHeadup.GetWindowByTabId(tabid);
            if (win != null) {
                this.SetEnableImage(win, gHeadup.Consts.EnabledIconPath);
                this.SetToolTip(win, 'headup');
            }
        }
        catch (err) {
            gHeadup.LogError('RestoreRegularIcon', err);
        }
    }