/*********************************************
*
* @Author: Eylon Yogev
*********************************************/

try {

    HeadupClass.prototype.tabGuid = 0;

    HeadupClass.prototype.NextGuid = function() {
        this.tabGuid++;
        return this.tabGuid.toString();
    }

    HeadupClass.prototype.CloseActivateTab = function(url, win) {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
        var mainWindow = wm.getMostRecentWindow("navigator:browser");
        mainWindow.gBrowser.removeCurrentTab();
    }


    HeadupClass.prototype.ActivateTab = function(url, win) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
            var browserEnumerator = wm.getEnumerator("navigator:browser");

            // Check each browser instance for our URL
            while (browserEnumerator.hasMoreElements()) {
                var browserWin = browserEnumerator.getNext();
                var tabbrowser = browserWin.getBrowser();

                // Check each tab of this browser instance
                var numTabs = tabbrowser.browsers.length;
                for (var index = 0; index < numTabs; index++) {
                    var currentBrowser = tabbrowser.getBrowserAtIndex(index);
                    if (currentBrowser.currentURI.spec.indexOf(url) != -1) {

                        // The URL is already opened. Select this tab.
                        tabbrowser.selectedTab = tabbrowser.mTabs[index];

                        // Focus *this* browser-window
                        browserWin.focus();

                        return true;
                    }
                }
            }

            return false;
        }
        catch (err) {
            gHeadup.LogError('ActivateTab', err);
        }
    }
    

    HeadupClass.prototype.FindTabByURL = function(url, win) {
        var num = win.gBrowser.browsers.length;
        for (var i = 0; i < num; i++) {
            var tab = win.gBrowser.getBrowserAtIndex(i);
            if (url == tab.currentURI.spec) {
                return tab;
            }
        }
        return null;
    }

    HeadupClass.prototype.InitTab = function(tab, win) {
        tab.Win = win;
        tab.Guid = gHeadup.NextGuid();
        tab.HintText = "0";
        tab.Doms = {};
        if (tab.contentDocument != null) {
            tab.contentDocument.Tab = tab;
            gHeadup.InitPage(tab.contentDocument);
        }
    }

    HeadupClass.prototype.SetHintText = function(text, tabid) {
        var tab = this.GetTabByTabId(tabid);
        tab.HintText = text;
    }

    HeadupClass.prototype.GetTabDomByTabId = function(tabid) {
        var tab = this.GetTabByTabId(tabid);
        if (tab != null)
            return tab.contentDocument;
        else
            return null;
    }

    HeadupClass.prototype.GetTabByTabId = function(tabid) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var enumerator = wm.getEnumerator(null);
            while (enumerator.hasMoreElements()) {
                var win = enumerator.getNext();
                if (win.location != gHeadup.Consts.SingleEngineChromPath) {
                    if (win.gBrowser != null) {
                        var num = win.gBrowser.browsers.length;
                        for (var i = 0; i < num; i++) {
                            if (win.gBrowser.getBrowserAtIndex(i).Guid == tabid)
                                return win.gBrowser.getBrowserAtIndex(i);
                        }
                    }
                }
            }
        }
        catch (err) {
            gHeadup.LogError('ForeachTab', err);
        }
        return null;
    }


    HeadupClass.prototype.GetWindowByTabId = function(tabid) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var enumerator = wm.getEnumerator(null);
            while (enumerator.hasMoreElements()) {
                var win = enumerator.getNext();
                if (win.location != gHeadup.Consts.SingleEngineChromPath) {
                    if (win.gBrowser != null) {
                        var num = win.gBrowser.browsers.length;
                        for (var i = 0; i < num; i++) {
                            if (win.gBrowser.getBrowserAtIndex(i).Guid == tabid)
                                return win;
                        }
                    }
                }
            }
        }
        catch (err) {
            gHeadup.LogError('GetWindowByTabId', err);
        }
        return null;
    }

    HeadupClass.prototype.GetWindowByWinId = function(winid) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var enumerator = wm.getEnumerator(null);
            while (enumerator.hasMoreElements()) {
                var win = enumerator.getNext();
                if (win.location != gHeadup.Consts.SingleEngineChromPath) {
                    if (win.Guid == winid)
                        return win;
                }
            }
        }
        catch (err) {
            gHeadup.LogError('GetWindowByWinId', err);
        }
        return null;
    }

    HeadupClass.prototype.GetActiveTab = function() {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
        var mainWindow = wm.getMostRecentWindow("navigator:browser");
        return mainWindow.gBrowser.selectedBrowser;
        //return win.gBrowser.selectedBrowser;
    }

    HeadupClass.prototype.GetActiveTabGuid = function() {
        return this.GetActiveTab().Guid;
    }

    HeadupClass.prototype.GetTabGuid = function(tab) {
        return tab.Guid;
    }

    HeadupClass.prototype.TabSelect = function(event, win) {
        // multitab support here
        var browser = event.target.linkedBrowser;
        if (gHeadup.IsMac()) {
            setTimeout(function() {
                gHeadup.SwitchToTab(browser);
            }, 50);
        }
        else {
            gHeadup.SwitchToTab(browser);
        }
    }

    HeadupClass.prototype.TabOpen = function(event, win) {
        var browser = event.target.linkedBrowser;
        // browser is the XUL element of the browser that's been added
        this.InitTab(browser, win);
    }

    HeadupClass.prototype.TabMove = function(event, win) {
    }

    HeadupClass.prototype.TabClose = function(event, win) {
        var browser = event.target.linkedBrowser;
        var tabid = browser.Guid;
        var data = {};
        data['tabid'] = tabid;
        gHeadup.FireEventInSingleWindow("TabClosed", data);
    }

    HeadupClass.prototype.SaveSingleWindowData = function(x, y, width, height, tabid) {
        var tab = this.GetTabByTabId(tabid);
        tab.SWX = x;
        tab.SWY = y;
        tab.SWWidth = width;
        tab.SWHeight = height;
        var scrollY = tab.contentDocument.documentElement.scrollTop;
        tab.SWScrollY = scrollY;
        this.MarkShownOnTab(tab, true);
    }

    HeadupClass.prototype.UpdateSizeData = function(width, height, tabid) {
        var tab = this.GetTabByTabId(tabid);
        tab.SWWidth = width;
        tab.SWHeight = height;
    }

    HeadupClass.prototype.ActiveTabSingleWindowClosed = function() {
        this.MarkShownOnTab(gBrowser.selectedBrowser, false);
    }

    HeadupClass.prototype.SingleWindowClosed = function(tab) {
        this.MarkShownOnTab(tab, false);
    }

    HeadupClass.prototype.IsActiveTab = function(tab) {
        return tab == this.GetWindowByTabId(tab.Guid).gBrowser.selectedBrowser;
    }

    HeadupClass.prototype.MarkShownOnTab = function(tab, value) {
        tab.SWShown = value;
    }

    HeadupClass.prototype.GetShownOnTab = function(tab) {
        return tab.SWShown;
    }

    HeadupClass.prototype.OpenNewTab = function(url, toSwitch) {
        try {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
            var mainWindow = wm.getMostRecentWindow("navigator:browser");

            var tab = mainWindow.gBrowser.addTab(url);
            if (toSwitch) {
                mainWindow.gBrowser.selectedTab = tab;
            }
        }
        catch (err) {
            gHeadup.LogError('OpenTab', err);
        }
    }

    HeadupClass.prototype.GotoURLInActiveTab = function(params) {
        var url = params['url'];
        gHeadup.InternalGotoURLInActiveTab(url);
    }

    HeadupClass.prototype.InternalGotoURLInActiveTab = function(url) {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
        var mainWindow = wm.getMostRecentWindow("navigator:browser");
        mainWindow.openUILink(url, mainWindow.gBrowser.selectedBrowser, false, true);
    }

    HeadupClass.prototype.GetContainingTab = function(dom, win) {
        try {
            var num = win.gBrowser.browsers.length;
            for (var i = 0; i < num; i++) {
                var curTab = win.gBrowser.getBrowserAtIndex(i);
                if (curTab.contentDocument == dom) {
                    return curTab;
                }
            }

        }
        catch (err) {
        }
        return null;
    }

    HeadupClass.prototype.GetHTMLFromPage = function(params) {
        try {
            var tabid = parseInt(params['tabid']);
            return this.GetTabDomByTabId(tabid).body.innerHTML;
        }
        catch (err) {
            gHeadup.LogError('GetHTMLFromPage', err);
        }
    }

    HeadupClass.prototype.GetTabParams = function(params) {
        try {
            var tabid = parseInt(params['tabid']);
            var tab = this.GetTabByTabId(tabid);
            var param = params['param'];
            if (param == 'x') {
                return tab.SWX;
            }
            else if (param == 'y') {
                return tab.SWY;
            }
            return null;
        }
        catch (err) {
            gHeadup.LogError('GetHTMLFromPage', err);
        }
    }

    HeadupClass.prototype.GetTabLocation = function(params) {
        var tabid = params['tabid'];
        var dom = this.GetTabDomByTabId(tabid);
        return dom.location.href;
    }

}
catch (err) {
    gHeadup.LogError('error prototyping Tabs: ' + err);
}