/*********************************************
* This file is responsible for versioning of the installed silverlight and running OS.
* Also checks for new headup verisons.
* @Author: Eylon Yogev
*********************************************/
try {
    HeadupClass.prototype.isSilverlightInstalled;

    HeadupClass.prototype.IsSilverlightInstalled = function() {
        try {
            if (navigator.plugins && navigator.plugins.length) {
                var x = navigator.plugins["Silverlight Plug-In"];
                if (x == null) {
                    // not installed
                    gHeadup.AddLogToLogWindow('silverlight not installed');
                    return false;
                }
                else {
                    for (var i = 0; i < x.length; i++) {
                        if (x[i].type == gHeadup.Consts.SilverVersionType) {
                            // installed with right verion!
                            gHeadup.AddLogToLogWindow('silverlight installed');
                            return true;
                        }
                    }

                    // version not found.
                    return false;
                }
            }
            else {
                // not installed.
                gHeadup.AddLogToLogWindow('silverlight not installed');
                return false;
            }
        }
        catch (err) {
            gHeadup.LogError('IsSilverlightInstalled', err);
            // probaly not installed.
            return false;
        }
    }

    HeadupClass.prototype.GetPlatform = function() {
        try {
            var platform = navigator.platform.toLowerCase();

            if (platform.indexOf('mac') != -1) {
                return 'mac';
            }

            if (platform.indexOf('linux') != -1) {
                return 'linux';
            }

            var osVersion = navigator.oscpu;
            if (osVersion.indexOf('6.0') != -1) {
                return 'vista';
            }

            return 'xp';
        }
        catch (err) {
            gHeadup.LogError('GetPlatform', err);
        }
    }

    HeadupClass.prototype.Platform = gHeadup.GetPlatform();

    HeadupClass.prototype.IsMac = function() {
        return this.Platform == 'mac';
    }

    HeadupClass.prototype.IsNewVersion = function() {

        var last = gHeadup.GetStringPref('LastVersion');
        if (gHeadup.Consts.Version != last) {
            gHeadup.SetStringPref('LastVersion', gHeadup.Consts.Version);
            gHeadup.SetStringPref('ShowInstallationDonePage', 'true');
            return true;
        }

        return false;
    }


    HeadupClass.prototype.NumberOfProcessors = function() {
        try {
            var envService = Components.classes["@mozilla.org/process/environment;1"]
                   .getService(Components.interfaces.nsIEnvironment);
            var number = envService.get('NUMBER_OF_PROCESSORS');
            return number;
        }
        catch (err) {
            gHeadup.LogError('NumberOfProcessors', err);
            return 0;
        }
    }
}
catch (err) {
    LogError('error prototyping Versioning: ' + err);
}