/*********************************************
*
* @Author: Eylon Yogev
*********************************************/

try {
    HeadupClass.prototype.AttachWindowEvents = function() {
        window.addEventListener("load", gHeadup.SingleWindowLoaded, false);
    }

    HeadupClass.prototype.PositionMouse = function(e) {
        return { y: (screen.height / 2) - 150, x: (screen.width / 2) - 150 }
    }

    HeadupClass.prototype.GetSelection = function(win) {
        try {
            var commandDispathcer = win.document.commandDispatcher;
            if (commandDispathcer != null) {
                return commandDispatcher.focusedWindow.getSelection();
            }
            else {
                return win.getSelection();
            }
        }
        catch (err) {
            gHeadup.LogError('GetSelection', err);
            return null;
        }
    }

    HeadupClass.prototype.myLoginWindow;

    HeadupClass.prototype.myHeadupWindows = {};

    HeadupClass.prototype.OpenXulWindow = function(name, xul, data, width, height) {
        var result = false;
        if (gHeadup.myHeadupWindows[name] == null) {
            gHeadup.myHeadupWindows[name] =
                window.openDialog(xul, '_blank', 'chrome=yes,centerscreen,minimizable,titlebar=yes,resizable=no,scrollbars=no,width=' + width + ',height=' + height, data);
            gHeadup.myHeadupWindows[name].addEventListener("close", gHeadup.OnXulWindowClosed, true, true);
            gHeadup.myHeadupWindows[name].name = name;
            result = true;
        }

        gHeadup.myHeadupWindows[name].focus();
        return result;
    }

    HeadupClass.prototype.CloseXulWindow = function(name, force) {
        try {
            if (gHeadup.myHeadupWindows[name] != null) {
                gHeadup.myHeadupWindows[name].removeEventListener("close", gHeadup.OnXulWindowClosed, true, true);
                gHeadup.myHeadupWindows[name].resizeTo(2, 2);
                gHeadup.myHeadupWindows[name].moveTo(4000, 4000);
                gHeadup.myHeadupWindows[name].content.src = 'about:blank';
                if (force) {
                    gHeadup.CloseXulWindowInternal(name);
                }
                else {
                    setTimeout(function() {
                        gHeadup.CloseXulWindowInternal(name);
                    }, 1000);
                }
            }
        }
        catch (err) {
            gHeadup.LogError('CloseXulWindow', err);
        }
    }

    HeadupClass.prototype.CloseAllXulWindows = function() {
        try {
            for (var winName in gHeadup.myHeadupWindows) {
                gHeadup.CloseXulWindow(winName, true);
            }
        }
        catch (err) {

        }
    }

    HeadupClass.prototype.MinimizeXulWindow = function(name) {
        if (gHeadup.myHeadupWindows[name] != null) {
            gHeadup.myHeadupWindows[name].minimize();
        }
    }

    HeadupClass.prototype.MaximizeXulWindow = function(name) {
        if (gHeadup.myHeadupWindows[name] != null) {
            gHeadup.myHeadupWindows[name].maximize();
        }
    }

    HeadupClass.prototype.RestoreXulWindow = function(name) {
        if (gHeadup.myHeadupWindows[name] != null) {
            gHeadup.myHeadupWindows[name].restore();
        }
    }

    HeadupClass.prototype.CloseXulWindowInternal = function(name) {
        if (gHeadup.myHeadupWindows[name] != null) {
            gHeadup.myHeadupWindows[name].close();
            gHeadup.myHeadupWindows[name] = null;
        }
    }

    HeadupClass.prototype.FocusXulWindow = function(name) {
        gHeadup.myHeadupWindows[name].focus();
    }

    HeadupClass.prototype.OnXulWindowClosed = function(event) {
        event.stopPropagation();
        event.preventDefault();
        var name = event.currentTarget.name;
        gHeadup.FireEventInWindow('XulWindowClosed', null, name);
    }

    HeadupClass.prototype.OpenRegularWindow = function(params) {
        try {
            var theurl = params['url'];
            var Height = params['Height'];
            var Width = params['Width'];
            var thetitle = params['title'];
            

            var winparams = { inn: {
                url: theurl,
                height: Height,
                width: Width,
                title: thetitle
            },
                out: null
            };

            var loginWindow = window.openDialog('chrome://keybitz/content/plain-window.xul',
            "", gHeadup.Consts.DefaultWindowFeatures, winparams);

            //if (this.IsBadURL(theurl)) {
                loginWindow.addEventListener("click", gHeadup.CloseOnClick, true);
                //myLoginWindow = loginWindow;
            //}
            
            loginWindow.focus();
            if (!loginWindow.gHeadup)
                loginWindow.gHeadup = new HeadupClass();
            loginWindow.gHeadup.isFocused = true;
        }
        catch (err) {
            gHeadup.LogError('OpenRegularWindow', err);
            return null;
        }
    }

    HeadupClass.prototype.IsBadURL = function(theurl) {
        var pos = theurl.indexOf("www.facebook.com/sharer.php");
        if (pos >= 0) {
            return true;
        }
        else {
            return false;
        }
    }

    HeadupClass.prototype.CloseOnClick = function(event) {
        var text = '';
        if (event.target.value != null)
            text = event.target.value;
        else
            text = event.target.text;
            
        text = text.toLowerCase();
        if (text == 'cancel' || text == 'close this window') {
            this.close();
        }
    }

    HeadupClass.prototype.BeginOpenWindow = function(params) {
        var theurl = params['url'];
        var opid = params['opId'];

        var Height = params['Height'];
        var Width = params['Width'];

        var hide = false; //params['hideCloseButton'];

        var thetitle = params['title'];
        var urls = params['closeurls'];
        var myreciver = params['reciever'];

        var winparams = { inn: {
            url: theurl,
            height: Height,
            width: Width,
            theopid: opid,
            hideCloseButton: hide,
            title: thetitle,
            closeUrls: urls,
            reciver: myreciver
        },
            out: null
        };

        var loginWindow = window.openDialog(
        gHeadup.Consts.LoginWindowChromPath,
        "",
        gHeadup.Consts.DefaultWindowFeatures,
        winparams);

        if (!loginWindow.gHeadup)
            loginWindow.gHeadup = new HeadupClass();
        loginWindow.gHeadup.isFocused = true;
    }

    HeadupClass.prototype.OpenTab = function(params) {
        var url = params['url'];
        this.InternalOpenTab(url);
    }

    HeadupClass.prototype.SetXulWindowTitle = function(name, title) {
        try
        {
            gHeadup.myHeadupWindows[name].title = title;
        }
        catch (err) {
            gHeadup.LogError('SetXulWindowTitle', err);
        }
    }

    HeadupClass.prototype.SetXulWindowWidthHeight = function(name, width, height) {
    try {
            gHeadup.myHeadupWindows[name].resizeTo(width, height);
        }
        catch (err) {
            gHeadup.LogError('SetXulWindowWidthHeight', err);
        }
    }

    HeadupClass.prototype.InternalOpenTab = function(url) {
        // Add tab, then make active
        gBrowser.selectedTab = gBrowser.addTab(url);
        //var newTab = gBrowser.addTab(url);
        var tabDoc = gBrowser.selectedBrowser.contentDocument;
    }

    HeadupClass.prototype.EndOpenWindow = function(result, opid, name) {
        var data = {};
        data["responsetext"] = result;
        data["opid"] = opid;
        gHeadup.FireEventInWindow('MethodCallback', data, name);
    }

    gHeadup.AttachWindowEvents();

}
catch (err) {
    LogError('error prototyping Window: ' + err);
}